<template>
  <FormulateForm
    class="form"
    #default="{ hasErrors, isLoading }"
    v-model="formValues"
    @submit="onFormSubmit"
  >
    <h2 class="form-title">Email</h2>
    <FormulateInput
      type="text"
      name="name"
      label="Your name"
      validation="required|min:5,length|max:50,length"
      validation-behavior="live"
    />
    <FormulateInput
      type="email"
      name="email"
      label="Your email"
      validation="required|email"
      validation-behavior="live"
    />
    <FormulateInput
      type="text"
      name="subject"
      label="Subject"
      validation="max:100,length"
      validation-behavior="live"
    />
    <FormulateInput
      class="form-message"
      type="textarea"
      name="message"
      label="Message"
      validation="required|max:500,length"
      validation-behavior="live"
      :help="`Keep it under 500 characters. ${500 - formValues.message.length} left.`"
    />
    <div class="form-submit-container">
      <FormulateInput
        class="form-submit"
        type="submit"
        :label="isLoading ? 'Sending...' : 'Send'"
        :disabled="hasErrors"
      />
      <p
        :class="[ sendStatus ]"
        class="form-status"
      >
        Send status: {{ sendStatus }}
      </p>
    </div>
  </FormulateForm>
</template>

<script>
export default {
  data () {
    return {
      formValues: {
        name: '',
        email: '',
        subject: '',
        message: '',
      },
      success: null,
    }
  },
  computed: {
    sendStatus() {
      if (this.success === null) return '';
      return this.success ? 'success' : 'error';
    }
  },
  methods: {
    async onFormSubmit(data) {
      try {
        await this.$axios.post('https://5d9f7fe94d823c0014dd323d.mockapi.io/api', data);
        this.success = true;
      } catch (_) {
        this.success = false;
      }
    }
  }
}
</script>

<style scoped>
.form {
  padding: 2em;
  border: 1px solid #a8a8a8;
  border-radius: .5em;
  max-width: 500px;
  box-sizing: border-box;
}

.form::v-deep input {
  width: 100%;
  padding: .5em;
  margin-bottom: 1em;
  box-sizing: border-box;
}

.form-submit-container {
  display: flex;
  justify-content: space-between;
}

.form-submit::v-deep button {
  padding: .5rem 1rem;
  margin-top: 1rem;
}

.form-submit::v-deep button:not(:disabled) {
  border: 1px solid #41b883;
  background: #adaf3f;
}

.form-title {
  margin-top: 0;
}

.form-message::v-deep textarea {
  min-width: 220px;
  max-width: calc(100% - 6px);
  width: calc(100% - 6px);
  min-height: 100px;
  height: 100px;
}

.form-status {
  padding: .5rem;
}

.form-status.error {
  background: red;
  color: white;
}

.form-status.success {
  background: #41b883;
}
</style>
